import { AiStudioAgentLongTextToolResponse } from './aiStudioAgentLongTextToolResponse.generated.js';
import { AiStudioAgentBasicTextToolResponse } from './aiStudioAgentBasicTextToolResponse.generated.js';
import { SerializedData } from '../serialization/json.js';
export type AiStudioAgentAskResponseTypeField = 'ai_agent_ask';
export declare class AiStudioAgentAskResponse {
    /**
     * The type of AI agent used to handle queries. */
    readonly type: AiStudioAgentAskResponseTypeField;
    /**
     * The state of the AI Agent capability. Possible values are: `enabled` and `disabled`. */
    readonly accessState: string;
    /**
     * The description of the AI Agent. */
    readonly description: string;
    /**
     * Custom instructions for the agent. */
    readonly customInstructions?: string | null;
    readonly longText?: AiStudioAgentLongTextToolResponse;
    readonly basicText?: AiStudioAgentBasicTextToolResponse;
    readonly longTextMulti?: AiStudioAgentLongTextToolResponse;
    readonly basicTextMulti?: AiStudioAgentBasicTextToolResponse;
    readonly rawData?: SerializedData;
    constructor(fields: Omit<AiStudioAgentAskResponse, 'type'> & Partial<Pick<AiStudioAgentAskResponse, 'type'>>);
}
export interface AiStudioAgentAskResponseInput {
    /**
     * The type of AI agent used to handle queries. */
    readonly type?: AiStudioAgentAskResponseTypeField;
    /**
     * The state of the AI Agent capability. Possible values are: `enabled` and `disabled`. */
    readonly accessState: string;
    /**
     * The description of the AI Agent. */
    readonly description: string;
    /**
     * Custom instructions for the agent. */
    readonly customInstructions?: string | null;
    readonly longText?: AiStudioAgentLongTextToolResponse;
    readonly basicText?: AiStudioAgentBasicTextToolResponse;
    readonly longTextMulti?: AiStudioAgentLongTextToolResponse;
    readonly basicTextMulti?: AiStudioAgentBasicTextToolResponse;
    readonly rawData?: SerializedData;
}
export declare function serializeAiStudioAgentAskResponseTypeField(val: AiStudioAgentAskResponseTypeField): SerializedData;
export declare function deserializeAiStudioAgentAskResponseTypeField(val: SerializedData): AiStudioAgentAskResponseTypeField;
export declare function serializeAiStudioAgentAskResponse(val: AiStudioAgentAskResponse): SerializedData;
export declare function deserializeAiStudioAgentAskResponse(val: SerializedData): AiStudioAgentAskResponse;
export declare function serializeAiStudioAgentAskResponseInput(val: AiStudioAgentAskResponseInput): SerializedData;
export declare function deserializeAiStudioAgentAskResponseInput(val: SerializedData): AiStudioAgentAskResponseInput;
//# sourceMappingURL=aiStudioAgentAskResponse.generated.d.ts.map