"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AiStudioAgentAskResponse = void 0;
exports.serializeAiStudioAgentAskResponseTypeField = serializeAiStudioAgentAskResponseTypeField;
exports.deserializeAiStudioAgentAskResponseTypeField = deserializeAiStudioAgentAskResponseTypeField;
exports.serializeAiStudioAgentAskResponse = serializeAiStudioAgentAskResponse;
exports.deserializeAiStudioAgentAskResponse = deserializeAiStudioAgentAskResponse;
exports.serializeAiStudioAgentAskResponseInput = serializeAiStudioAgentAskResponseInput;
exports.deserializeAiStudioAgentAskResponseInput = deserializeAiStudioAgentAskResponseInput;
const aiStudioAgentLongTextToolResponse_generated_js_1 = require("./aiStudioAgentLongTextToolResponse.generated.js");
const aiStudioAgentLongTextToolResponse_generated_js_2 = require("./aiStudioAgentLongTextToolResponse.generated.js");
const aiStudioAgentBasicTextToolResponse_generated_js_1 = require("./aiStudioAgentBasicTextToolResponse.generated.js");
const aiStudioAgentBasicTextToolResponse_generated_js_2 = require("./aiStudioAgentBasicTextToolResponse.generated.js");
const errors_js_1 = require("../box/errors.js");
const json_js_1 = require("../serialization/json.js");
const json_js_2 = require("../serialization/json.js");
class AiStudioAgentAskResponse {
    constructor(fields) {
        /**
         * The type of AI agent used to handle queries. */
        this.type = 'ai_agent_ask';
        if (fields.type !== undefined) {
            this.type = fields.type;
        }
        if (fields.accessState !== undefined) {
            this.accessState = fields.accessState;
        }
        if (fields.description !== undefined) {
            this.description = fields.description;
        }
        if (fields.customInstructions !== undefined) {
            this.customInstructions = fields.customInstructions;
        }
        if (fields.longText !== undefined) {
            this.longText = fields.longText;
        }
        if (fields.basicText !== undefined) {
            this.basicText = fields.basicText;
        }
        if (fields.longTextMulti !== undefined) {
            this.longTextMulti = fields.longTextMulti;
        }
        if (fields.basicTextMulti !== undefined) {
            this.basicTextMulti = fields.basicTextMulti;
        }
        if (fields.rawData !== undefined) {
            this.rawData = fields.rawData;
        }
    }
}
exports.AiStudioAgentAskResponse = AiStudioAgentAskResponse;
function serializeAiStudioAgentAskResponseTypeField(val) {
    return val;
}
function deserializeAiStudioAgentAskResponseTypeField(val) {
    if (val == 'ai_agent_ask') {
        return val;
    }
    throw new errors_js_1.BoxSdkError({
        message: "Can't deserialize AiStudioAgentAskResponseTypeField",
    });
}
function serializeAiStudioAgentAskResponse(val) {
    return {
        ['type']: serializeAiStudioAgentAskResponseTypeField(val.type),
        ['access_state']: val.accessState,
        ['description']: val.description,
        ['custom_instructions']: val.customInstructions,
        ['long_text']: val.longText == void 0
            ? val.longText
            : (0, aiStudioAgentLongTextToolResponse_generated_js_1.serializeAiStudioAgentLongTextToolResponse)(val.longText),
        ['basic_text']: val.basicText == void 0
            ? val.basicText
            : (0, aiStudioAgentBasicTextToolResponse_generated_js_1.serializeAiStudioAgentBasicTextToolResponse)(val.basicText),
        ['long_text_multi']: val.longTextMulti == void 0
            ? val.longTextMulti
            : (0, aiStudioAgentLongTextToolResponse_generated_js_1.serializeAiStudioAgentLongTextToolResponse)(val.longTextMulti),
        ['basic_text_multi']: val.basicTextMulti == void 0
            ? val.basicTextMulti
            : (0, aiStudioAgentBasicTextToolResponse_generated_js_1.serializeAiStudioAgentBasicTextToolResponse)(val.basicTextMulti),
    };
}
function deserializeAiStudioAgentAskResponse(val) {
    if (!(0, json_js_2.sdIsMap)(val)) {
        throw new errors_js_1.BoxSdkError({
            message: 'Expecting a map for "AiStudioAgentAskResponse"',
        });
    }
    if (val.type == void 0) {
        throw new errors_js_1.BoxSdkError({
            message: 'Expecting "type" of type "AiStudioAgentAskResponse" to be defined',
        });
    }
    const type = deserializeAiStudioAgentAskResponseTypeField(val.type);
    if (val.access_state == void 0) {
        throw new errors_js_1.BoxSdkError({
            message: 'Expecting "access_state" of type "AiStudioAgentAskResponse" to be defined',
        });
    }
    if (!(0, json_js_1.sdIsString)(val.access_state)) {
        throw new errors_js_1.BoxSdkError({
            message: 'Expecting string for "access_state" of type "AiStudioAgentAskResponse"',
        });
    }
    const accessState = val.access_state;
    if (val.description == void 0) {
        throw new errors_js_1.BoxSdkError({
            message: 'Expecting "description" of type "AiStudioAgentAskResponse" to be defined',
        });
    }
    if (!(0, json_js_1.sdIsString)(val.description)) {
        throw new errors_js_1.BoxSdkError({
            message: 'Expecting string for "description" of type "AiStudioAgentAskResponse"',
        });
    }
    const description = val.description;
    if (!(val.custom_instructions == void 0) &&
        !(0, json_js_1.sdIsString)(val.custom_instructions)) {
        throw new errors_js_1.BoxSdkError({
            message: 'Expecting string for "custom_instructions" of type "AiStudioAgentAskResponse"',
        });
    }
    const customInstructions = val.custom_instructions == void 0 ? void 0 : val.custom_instructions;
    const longText = val.long_text == void 0
        ? void 0
        : (0, aiStudioAgentLongTextToolResponse_generated_js_2.deserializeAiStudioAgentLongTextToolResponse)(val.long_text);
    const basicText = val.basic_text == void 0
        ? void 0
        : (0, aiStudioAgentBasicTextToolResponse_generated_js_2.deserializeAiStudioAgentBasicTextToolResponse)(val.basic_text);
    const longTextMulti = val.long_text_multi == void 0
        ? void 0
        : (0, aiStudioAgentLongTextToolResponse_generated_js_2.deserializeAiStudioAgentLongTextToolResponse)(val.long_text_multi);
    const basicTextMulti = val.basic_text_multi == void 0
        ? void 0
        : (0, aiStudioAgentBasicTextToolResponse_generated_js_2.deserializeAiStudioAgentBasicTextToolResponse)(val.basic_text_multi);
    return {
        type: type,
        accessState: accessState,
        description: description,
        customInstructions: customInstructions,
        longText: longText,
        basicText: basicText,
        longTextMulti: longTextMulti,
        basicTextMulti: basicTextMulti,
    };
}
function serializeAiStudioAgentAskResponseInput(val) {
    return {
        ['type']: val.type == void 0
            ? val.type
            : serializeAiStudioAgentAskResponseTypeField(val.type),
        ['access_state']: val.accessState,
        ['description']: val.description,
        ['custom_instructions']: val.customInstructions,
        ['long_text']: val.longText == void 0
            ? val.longText
            : (0, aiStudioAgentLongTextToolResponse_generated_js_1.serializeAiStudioAgentLongTextToolResponse)(val.longText),
        ['basic_text']: val.basicText == void 0
            ? val.basicText
            : (0, aiStudioAgentBasicTextToolResponse_generated_js_1.serializeAiStudioAgentBasicTextToolResponse)(val.basicText),
        ['long_text_multi']: val.longTextMulti == void 0
            ? val.longTextMulti
            : (0, aiStudioAgentLongTextToolResponse_generated_js_1.serializeAiStudioAgentLongTextToolResponse)(val.longTextMulti),
        ['basic_text_multi']: val.basicTextMulti == void 0
            ? val.basicTextMulti
            : (0, aiStudioAgentBasicTextToolResponse_generated_js_1.serializeAiStudioAgentBasicTextToolResponse)(val.basicTextMulti),
    };
}
function deserializeAiStudioAgentAskResponseInput(val) {
    if (!(0, json_js_2.sdIsMap)(val)) {
        throw new errors_js_1.BoxSdkError({
            message: 'Expecting a map for "AiStudioAgentAskResponseInput"',
        });
    }
    const type = val.type == void 0
        ? void 0
        : deserializeAiStudioAgentAskResponseTypeField(val.type);
    if (val.access_state == void 0) {
        throw new errors_js_1.BoxSdkError({
            message: 'Expecting "access_state" of type "AiStudioAgentAskResponseInput" to be defined',
        });
    }
    if (!(0, json_js_1.sdIsString)(val.access_state)) {
        throw new errors_js_1.BoxSdkError({
            message: 'Expecting string for "access_state" of type "AiStudioAgentAskResponseInput"',
        });
    }
    const accessState = val.access_state;
    if (val.description == void 0) {
        throw new errors_js_1.BoxSdkError({
            message: 'Expecting "description" of type "AiStudioAgentAskResponseInput" to be defined',
        });
    }
    if (!(0, json_js_1.sdIsString)(val.description)) {
        throw new errors_js_1.BoxSdkError({
            message: 'Expecting string for "description" of type "AiStudioAgentAskResponseInput"',
        });
    }
    const description = val.description;
    if (!(val.custom_instructions == void 0) &&
        !(0, json_js_1.sdIsString)(val.custom_instructions)) {
        throw new errors_js_1.BoxSdkError({
            message: 'Expecting string for "custom_instructions" of type "AiStudioAgentAskResponseInput"',
        });
    }
    const customInstructions = val.custom_instructions == void 0 ? void 0 : val.custom_instructions;
    const longText = val.long_text == void 0
        ? void 0
        : (0, aiStudioAgentLongTextToolResponse_generated_js_2.deserializeAiStudioAgentLongTextToolResponse)(val.long_text);
    const basicText = val.basic_text == void 0
        ? void 0
        : (0, aiStudioAgentBasicTextToolResponse_generated_js_2.deserializeAiStudioAgentBasicTextToolResponse)(val.basic_text);
    const longTextMulti = val.long_text_multi == void 0
        ? void 0
        : (0, aiStudioAgentLongTextToolResponse_generated_js_2.deserializeAiStudioAgentLongTextToolResponse)(val.long_text_multi);
    const basicTextMulti = val.basic_text_multi == void 0
        ? void 0
        : (0, aiStudioAgentBasicTextToolResponse_generated_js_2.deserializeAiStudioAgentBasicTextToolResponse)(val.basic_text_multi);
    return {
        type: type,
        accessState: accessState,
        description: description,
        customInstructions: customInstructions,
        longText: longText,
        basicText: basicText,
        longTextMulti: longTextMulti,
        basicTextMulti: basicTextMulti,
    };
}
//# sourceMappingURL=aiStudioAgentAskResponse.generated.js.map